/**
 * Grunt File for Function Stack
 * @param g - grunt
 */
var grunt = function (g) {
  // initialize grunt
  g.initConfig({
    pkg: g.file.readJSON('package.json'),
    watch: {
      files: ['test/*', 'src/*.js'],
      tasks: ['test']
    },
    qunit: {
      all: ['test/FunctionStackTest.html']
    },
    uglify: {
      options: {
        // TODO: remove before production
        //compress: {
        // drop_console: true
        //},
        sourceMap: true
        //sourceMapIncludeSources: true
      },
      target: {
        files:[{
          src:'src/fs.js',
          dest:'dist/fs.min.js'
        }]
      }
    }
  });

  // load up tasks
  g.loadNpmTasks('grunt-contrib-watch');
  g.loadNpmTasks('grunt-contrib-uglify');
  g.loadNpmTasks('grunt-contrib-qunit');

  // register tasks
  g.registerTask('default', ['qunit', 'uglify']);
  g.registerTask('test', ['qunit']);
};

module.exports = grunt;